package hal

type Page struct {
	Referenced bool
	PageNumber uint16
}

type PageTable []*Page

type Address uint16

func (address Address) PageNumber() uint16 {
	return uint16(address) >> 10
}

func (address Address) Offset() uint16 {
	return uint16(address) & 0x03FF
}

func (table *PageTable) Find(address Address) {
	// 10 bit for one register in a page
	// 6 bit to address the page
	// 000010 | 0000000011
	// -> Page 2, offset 3

	// Find the page with that number

	// Check if it is already loaded
	// Load it if not
}
